diff --git a/libpurple/purplecontact.c b/libpurple/purplecontactinfo.c
copy from libpurple/purplecontact.c
copy to libpurple/purplecontactinfo.c
--- a/libpurple/purplecontact.c
+++ b/libpurple/purplecontactinfo.c
@@ -16,14 +16,13 @@
  * along with this program; if not, see <https://www.gnu.org/licenses/>.
  */
 
-#include "purplecontact.h"
+#include "purplecontactinfo.h"
 
 #include "purpleenums.h"
 #include "util.h"
 
 typedef struct  {
 	gchar *id;
-	PurpleAccount *account;
 
 	gchar *username;
 	gchar *display_name;
@@ -37,13 +36,12 @@
 
 	PurplePerson *person;
 
-	PurpleContactPermission permission;
-} PurpleContactPrivate;
+	PurpleContactInfoPermission permission;
+} PurpleContactInfoPrivate;
 
 enum {
 	PROP_0,
 	PROP_ID,
-	PROP_ACCOUNT,
 	PROP_USERNAME,
 	PROP_DISPLAY_NAME,
 	PROP_ALIAS,
@@ -56,75 +54,49 @@
 };
 static GParamSpec *properties[N_PROPERTIES] = {NULL, };
 
-G_DEFINE_TYPE_WITH_PRIVATE(PurpleContact, purple_contact, G_TYPE_OBJECT)
-
-/******************************************************************************
- * Helpers
- *****************************************************************************/
-static void
-purple_contact_set_account(PurpleContact *contact, PurpleAccount *account) {
-	PurpleContactPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
-	g_return_if_fail(PURPLE_IS_ACCOUNT(account));
-
-	priv = purple_contact_get_instance_private(contact);
-
-	if(g_set_object(&priv->account, account)) {
-		g_object_notify_by_pspec(G_OBJECT(contact), properties[PROP_ACCOUNT]);
-	}
-}
-
-static PurpleAccount *
-purple_contact_default_get_account(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
-
-	priv = purple_contact_get_instance_private(contact);
-
-	return priv->account;
-}
+G_DEFINE_TYPE_WITH_PRIVATE(PurpleContactInfo, purple_contact_info,
+                           G_TYPE_OBJECT)
 
 /******************************************************************************
  * GObject Implementation
  *****************************************************************************/
 static void
-purple_contact_get_property(GObject *obj, guint param_id, GValue *value,
-                            GParamSpec *pspec)
+purple_contact_info_get_property(GObject *obj, guint param_id, GValue *value,
+                                 GParamSpec *pspec)
 {
-	PurpleContact *contact = PURPLE_CONTACT(obj);
+	PurpleContactInfo *contact = PURPLE_CONTACT_INFO(obj);
 
 	switch(param_id) {
 		case PROP_ID:
-			g_value_set_string(value, purple_contact_get_id(contact));
-			break;
-		case PROP_ACCOUNT:
-			g_value_set_object(value, purple_contact_get_account(contact));
+			g_value_set_string(value, purple_contact_info_get_id(contact));
 			break;
 		case PROP_USERNAME:
-			g_value_set_string(value, purple_contact_get_username(contact));
+			g_value_set_string(value,
+			                   purple_contact_info_get_username(contact));
 			break;
 		case PROP_DISPLAY_NAME:
-			g_value_set_string(value, purple_contact_get_display_name(contact));
+			g_value_set_string(value,
+			                   purple_contact_info_get_display_name(contact));
 			break;
 		case PROP_ALIAS:
-			g_value_set_string(value, purple_contact_get_alias(contact));
+			g_value_set_string(value, purple_contact_info_get_alias(contact));
 			break;
 		case PROP_AVATAR:
-			g_value_set_object(value, purple_contact_get_avatar(contact));
+			g_value_set_object(value, purple_contact_info_get_avatar(contact));
 			break;
 		case PROP_PRESENCE:
-			g_value_set_object(value, purple_contact_get_presence(contact));
+			g_value_set_object(value,
+			                   purple_contact_info_get_presence(contact));
 			break;
 		case PROP_TAGS:
-			g_value_set_object(value, purple_contact_get_tags(contact));
+			g_value_set_object(value, purple_contact_info_get_tags(contact));
 			break;
 		case PROP_PERSON:
-			g_value_set_object(value, purple_contact_get_person(contact));
+			g_value_set_object(value, purple_contact_info_get_person(contact));
 			break;
 		case PROP_PERMISSION:
-			g_value_set_enum(value, purple_contact_get_permission(contact));
+			g_value_set_enum(value,
+			                 purple_contact_info_get_permission(contact));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -133,35 +105,35 @@
 }
 
 static void
-purple_contact_set_property(GObject *obj, guint param_id, const GValue *value,
-                            GParamSpec *pspec)
+purple_contact_info_set_property(GObject *obj, guint param_id,
+                                 const GValue *value, GParamSpec *pspec)
 {
-	PurpleContact *contact = PURPLE_CONTACT(obj);
+	PurpleContactInfo *contact = PURPLE_CONTACT_INFO(obj);
 
 	switch(param_id) {
 		case PROP_ID:
-			purple_contact_set_id(contact, g_value_get_string(value));
-			break;
-		case PROP_ACCOUNT:
-			purple_contact_set_account(contact, g_value_get_object(value));
+			purple_contact_info_set_id(contact, g_value_get_string(value));
 			break;
 		case PROP_USERNAME:
-			purple_contact_set_username(contact, g_value_get_string(value));
+			purple_contact_info_set_username(contact,
+			                                 g_value_get_string(value));
 			break;
 		case PROP_DISPLAY_NAME:
-			purple_contact_set_display_name(contact, g_value_get_string(value));
+			purple_contact_info_set_display_name(contact,
+			                                     g_value_get_string(value));
 			break;
 		case PROP_ALIAS:
-			purple_contact_set_alias(contact, g_value_get_string(value));
+			purple_contact_info_set_alias(contact, g_value_get_string(value));
 			break;
 		case PROP_AVATAR:
-			purple_contact_set_avatar(contact, g_value_get_object(value));
+			purple_contact_info_set_avatar(contact, g_value_get_object(value));
 			break;
 		case PROP_PERSON:
-			purple_contact_set_person(contact, g_value_get_object(value));
+			purple_contact_info_set_person(contact, g_value_get_object(value));
 			break;
 		case PROP_PERMISSION:
-			purple_contact_set_permission(contact, g_value_get_enum(value));
+			purple_contact_info_set_permission(contact,
+			                                   g_value_get_enum(value));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -170,69 +142,72 @@
 }
 
 static void
-purple_contact_dispose(GObject *obj) {
-	PurpleContact *contact = PURPLE_CONTACT(obj);
-	PurpleContactPrivate *priv = purple_contact_get_instance_private(contact);
+purple_contact_info_dispose(GObject *obj) {
+	PurpleContactInfo *contact = PURPLE_CONTACT_INFO(obj);
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_clear_object(&priv->account);
+	priv = purple_contact_info_get_instance_private(contact);
+
 	g_clear_object(&priv->avatar);
 	g_clear_object(&priv->presence);
 	g_clear_object(&priv->tags);
 	g_clear_object(&priv->person);
 
-	G_OBJECT_CLASS(purple_contact_parent_class)->dispose(obj);
+	G_OBJECT_CLASS(purple_contact_info_parent_class)->dispose(obj);
 }
 
 static void
-purple_contact_finalize(GObject *obj) {
-	PurpleContact *contact = PURPLE_CONTACT(obj);
-	PurpleContactPrivate *priv = purple_contact_get_instance_private(contact);
+purple_contact_info_finalize(GObject *obj) {
+	PurpleContactInfo *contact = PURPLE_CONTACT_INFO(obj);
+	PurpleContactInfoPrivate *priv = NULL;
+
+	priv = purple_contact_info_get_instance_private(contact);
 
 	g_clear_pointer(&priv->id, g_free);
 	g_clear_pointer(&priv->username, g_free);
 	g_clear_pointer(&priv->display_name, g_free);
 	g_clear_pointer(&priv->alias, g_free);
 
-	G_OBJECT_CLASS(purple_contact_parent_class)->finalize(obj);
+	G_OBJECT_CLASS(purple_contact_info_parent_class)->finalize(obj);
 }
 
 static void
-purple_contact_constructed(GObject *obj) {
-	PurpleContact *contact = NULL;
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_constructed(GObject *obj) {
+	PurpleContactInfo *contact = NULL;
+	PurpleContactInfoPrivate *priv = NULL;
 
-	G_OBJECT_CLASS(purple_contact_parent_class)->constructed(obj);
+	G_OBJECT_CLASS(purple_contact_info_parent_class)->constructed(obj);
 
-	contact = PURPLE_CONTACT(obj);
-	priv = purple_contact_get_instance_private(contact);
+	contact = PURPLE_CONTACT_INFO(obj);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	if(priv->id == NULL) {
-		purple_contact_set_id(contact, NULL);
+		purple_contact_info_set_id(contact, NULL);
 	}
 }
 
 static void
-purple_contact_init(PurpleContact *contact) {
-	PurpleContactPrivate *priv = purple_contact_get_instance_private(contact);
+purple_contact_info_init(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
+
+	priv = purple_contact_info_get_instance_private(contact);
 
 	priv->tags = purple_tags_new();
 	priv->presence = g_object_new(PURPLE_TYPE_PRESENCE, NULL);
 }
 
 static void
-purple_contact_class_init(PurpleContactClass *klass) {
+purple_contact_info_class_init(PurpleContactInfoClass *klass) {
 	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
 
-	klass->get_account = purple_contact_default_get_account;
-
-	obj_class->constructed = purple_contact_constructed;
-	obj_class->dispose = purple_contact_dispose;
-	obj_class->finalize = purple_contact_finalize;
-	obj_class->get_property = purple_contact_get_property;
-	obj_class->set_property = purple_contact_set_property;
+	obj_class->constructed = purple_contact_info_constructed;
+	obj_class->dispose = purple_contact_info_dispose;
+	obj_class->finalize = purple_contact_info_finalize;
+	obj_class->get_property = purple_contact_info_get_property;
+	obj_class->set_property = purple_contact_info_set_property;
 
 	/**
-	 * PurpleContact:id:
+	 * PurpleContactInfo:id:
 	 *
 	 * The protocol specific id for the contact.
 	 *
@@ -245,20 +220,7 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:account:
-	 *
-	 * The account that this contact belongs to.
-	 *
-	 * Since: 3.0.0
-	 */
-	properties[PROP_ACCOUNT] = g_param_spec_object(
-		"account", "account",
-		"The account this contact belongs to",
-		PURPLE_TYPE_ACCOUNT,
-		G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_STATIC_STRINGS);
-
-	/**
-	 * PurpleContact:username:
+	 * PurpleContactInfo:username:
 	 *
 	 * The username for this contact. In rare cases this can change, like when
 	 * a user changes their "nick" on IRC which is their user name.
@@ -272,7 +234,7 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:display-name:
+	 * PurpleContactInfo:display-name:
 	 *
 	 * The display name for this contact. This is generally set by the person
 	 * the contact is representing and controlled via the protocol plugin.
@@ -286,7 +248,7 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:alias:
+	 * PurpleContactInfo:alias:
 	 *
 	 * The alias for this contact. This is controlled by the libpurple user and
 	 * may be used by the protocol if it allows for aliasing.
@@ -300,7 +262,7 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:avatar:
+	 * PurpleContactInfo:avatar:
 	 *
 	 * The avatar for this contact. This is typically controlled by the protocol
 	 * and should only be read by others.
@@ -314,7 +276,7 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:presence:
+	 * PurpleContactInfo:presence:
 	 *
 	 * The [class@Purple.Presence] for this contact. This is typically
 	 * controlled by the protocol and should only be read by others.
@@ -328,7 +290,7 @@
 		G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:tags:
+	 * PurpleContactInfo:tags:
 	 *
 	 * The [class@Purple.Tags] for this contact.
 	 *
@@ -341,7 +303,7 @@
 		G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:person:
+	 * PurpleContactInfo:person:
 	 *
 	 * The [class@Purple.Person] that this contact belongs to.
 	 *
@@ -354,7 +316,7 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	/**
-	 * PurpleContact:permission:
+	 * PurpleContactInfo:permission:
 	 *
 	 * The permission level for the contact.
 	 *
@@ -363,8 +325,8 @@
 	properties[PROP_PERMISSION] = g_param_spec_enum(
 		"permission", "permission",
 		"The permission level of the contact",
-		PURPLE_TYPE_CONTACT_PERMISSION,
-		PURPLE_CONTACT_PERMISSION_UNSET,
+		PURPLE_TYPE_CONTACT_INFO_PERMISSION,
+		PURPLE_CONTACT_INFO_PERMISSION_UNSET,
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
 
 	g_object_class_install_properties(obj_class, N_PROPERTIES, properties);
@@ -373,49 +335,32 @@
 /******************************************************************************
  * Public API
  *****************************************************************************/
-PurpleContact *
-purple_contact_new(PurpleAccount *account, const gchar *id) {
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-
+PurpleContactInfo *
+purple_contact_info_new(const gchar *id) {
 	return g_object_new(
-		PURPLE_TYPE_CONTACT,
-		"account", account,
+		PURPLE_TYPE_CONTACT_INFO,
 		"id", id,
 		NULL);
 }
 
-PurpleAccount *
-purple_contact_get_account(PurpleContact *contact) {
-	PurpleContactClass *klass = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
-
-	klass = PURPLE_CONTACT_GET_CLASS(contact);
-	if(klass != NULL && klass->get_account != NULL) {
-		return klass->get_account(contact);
-	}
+const gchar *
+purple_contact_info_get_id(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	return NULL;
-}
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-const gchar *
-purple_contact_get_id(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
-
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->id;
 }
 
 void
-purple_contact_set_id(PurpleContact *contact, const gchar *id) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_set_id(PurpleContactInfo *contact, const gchar *id) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	g_free(priv->id);
 	priv->id = g_strdup(id);
@@ -424,24 +369,26 @@
 }
 
 const gchar *
-purple_contact_get_username(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_username(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->username;
 }
 
 void
-purple_contact_set_username(PurpleContact *contact, const gchar *username) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_set_username(PurpleContactInfo *contact,
+                                 const gchar *username)
+{
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 	g_return_if_fail(username != NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	g_free(priv->username);
 	priv->username = g_strdup(username);
@@ -450,25 +397,25 @@
 }
 
 const gchar *
-purple_contact_get_display_name(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_display_name(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->display_name;
 }
 
 void
-purple_contact_set_display_name(PurpleContact *contact,
-                                const gchar *display_name)
+purple_contact_info_set_display_name(PurpleContactInfo *contact,
+                                     const gchar *display_name)
 {
-	PurpleContactPrivate *priv = NULL;
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	g_free(priv->display_name);
 	priv->display_name = g_strdup(display_name);
@@ -477,23 +424,23 @@
 }
 
 const gchar *
-purple_contact_get_alias(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_alias(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->alias;
 }
 
 void
-purple_contact_set_alias(PurpleContact *contact, const gchar *alias) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_set_alias(PurpleContactInfo *contact, const gchar *alias) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	g_free(priv->alias);
 	priv->alias = g_strdup(alias);
@@ -502,23 +449,23 @@
 }
 
 GdkPixbuf *
-purple_contact_get_avatar(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_avatar(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->avatar;
 }
 
 void
-purple_contact_set_avatar(PurpleContact *contact, GdkPixbuf *avatar) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_set_avatar(PurpleContactInfo *contact, GdkPixbuf *avatar) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	if(g_set_object(&priv->avatar, avatar)) {
 		g_object_notify_by_pspec(G_OBJECT(contact), properties[PROP_AVATAR]);
@@ -526,34 +473,36 @@
 }
 
 PurplePresence *
-purple_contact_get_presence(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_presence(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->presence;
 }
 
 PurpleTags *
-purple_contact_get_tags(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_tags(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->tags;
 }
 
 void
-purple_contact_set_person(PurpleContact *contact, PurplePerson *person) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_set_person(PurpleContactInfo *contact,
+                               PurplePerson *person)
+{
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	if(g_set_object(&priv->person, person)) {
 		g_object_notify_by_pspec(G_OBJECT(contact), properties[PROP_PERSON]);
@@ -561,37 +510,37 @@
 }
 
 PurplePerson *
-purple_contact_get_person(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_person(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->person;
 }
 
-PurpleContactPermission
-purple_contact_get_permission(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+PurpleContactInfoPermission
+purple_contact_info_get_permission(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact),
-	                     PURPLE_CONTACT_PERMISSION_UNSET);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact),
+	                     PURPLE_CONTACT_INFO_PERMISSION_UNSET);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	return priv->permission;
 }
 
 void
-purple_contact_set_permission(PurpleContact *contact,
-                              PurpleContactPermission permission)
+purple_contact_info_set_permission(PurpleContactInfo *contact,
+                                   PurpleContactInfoPermission permission)
 {
-	PurpleContactPrivate *priv = NULL;
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	priv->permission = permission;
 
@@ -599,12 +548,12 @@
 }
 
 const char *
-purple_contact_get_name_for_display(PurpleContact *contact) {
-	PurpleContactPrivate *priv = NULL;
+purple_contact_info_get_name_for_display(PurpleContactInfo *contact) {
+	PurpleContactInfoPrivate *priv = NULL;
 
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), NULL);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), NULL);
 
-	priv = purple_contact_get_instance_private(contact);
+	priv = purple_contact_info_get_instance_private(contact);
 
 	/* If contact is associated with a PurplePerson that has an alias set,
 	 * return the alias of that PurplePerson.
@@ -637,7 +586,7 @@
 }
 
 int
-purple_contact_compare(PurpleContact *a, PurpleContact *b) {
+purple_contact_info_compare(PurpleContactInfo *a, PurpleContactInfo *b) {
 	PurplePerson *person_a = NULL;
 	PurplePerson *person_b = NULL;
 	const char *name_a = NULL;
@@ -653,8 +602,8 @@
 	}
 
 	/* Check if the contacts have persons associated with them. */
-	person_a = purple_contact_get_person(a);
-	person_b = purple_contact_get_person(b);
+	person_a = purple_contact_info_get_person(a);
+	person_b = purple_contact_info_get_person(b);
 
 	if(person_a != NULL && person_b == NULL) {
 		return -1;
@@ -663,8 +612,8 @@
 	}
 
 	/* Finally get the names for the displaying and compare those. */
-	name_a = purple_contact_get_name_for_display(a);
-	name_b = purple_contact_get_name_for_display(b);
+	name_a = purple_contact_info_get_name_for_display(a);
+	name_b = purple_contact_info_get_name_for_display(b);
 
 	return purple_utf8_strcasecmp(name_a, name_b);
 }
diff --git a/libpurple/purplecontactmanager.c b/libpurple/purplecontactmanager.c
--- a/libpurple/purplecontactmanager.c
+++ b/libpurple/purplecontactmanager.c
@@ -48,11 +48,13 @@
 {
 	PurpleContact *contact_a = (gpointer)a;
 	PurpleContact *contact_b = (gpointer)b;
+	PurpleContactInfo *info_a = PURPLE_CONTACT_INFO(contact_a);
+	PurpleContactInfo *info_b = PURPLE_CONTACT_INFO(contact_b);
 	const gchar *username_a = NULL;
 	const gchar *username_b = NULL;
 
-	username_a = purple_contact_get_username(contact_a);
-	username_b = purple_contact_get_username(contact_b);
+	username_a = purple_contact_info_get_username(info_a);
+	username_b = purple_contact_info_get_username(info_b);
 
 	return purple_strequal(username_a, username_b);
 }
@@ -64,8 +66,8 @@
 	const gchar *id_a = NULL;
 	const gchar *id_b = NULL;
 
-	id_a = purple_contact_get_id(contact_a);
-	id_b = purple_contact_get_id(contact_b);
+	id_a = purple_contact_info_get_id(PURPLE_CONTACT_INFO(contact_a));
+	id_b = purple_contact_info_get_id(PURPLE_CONTACT_INFO(contact_b));
 
 	return purple_strequal(id_a, id_b);
 }
@@ -260,8 +262,9 @@
 		added = TRUE;
 	} else {
 		if(g_list_store_find(contacts, contact, NULL)) {
-			const gchar *username = purple_contact_get_username(contact);
-			const gchar *id = purple_contact_get_id(contact);
+			PurpleContactInfo *info = PURPLE_CONTACT_INFO(contact);
+			const gchar *username = purple_contact_info_get_username(info);
+			const gchar *id = purple_contact_info_get_id(info);
 
 			g_warning("double add detected for contact %s:%s", id, username);
 
@@ -382,7 +385,7 @@
 	}
 
 	needle = purple_contact_new(account, NULL);
-	purple_contact_set_username(needle, username);
+	purple_contact_info_set_username(PURPLE_CONTACT_INFO(needle), username);
 	found = g_list_store_find_with_equal_func(contacts, needle,
 	                                          purple_contact_manager_find_with_username_helper,
 	                                          &position);
@@ -435,6 +438,7 @@
 {
 	PurpleAccount *account = NULL;
 	PurpleContact *contact = NULL;
+	PurpleContactInfo *info = NULL;
 	PurplePresence *buddy_presence = NULL;
 	PurplePresence *contact_presence = NULL;
 	const gchar *id = NULL;
@@ -446,6 +450,7 @@
 	account = purple_buddy_get_account(buddy);
 	id = purple_buddy_get_id(buddy);
 	contact = purple_contact_new(account, id);
+	info = PURPLE_CONTACT_INFO(contact);
 
 	/* Bind all of the properties. */
 	g_object_bind_property(buddy, "name", contact, "username",
@@ -456,7 +461,7 @@
 	                       G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL);
 
 	buddy_presence = purple_buddy_get_presence(buddy);
-	contact_presence = purple_contact_get_presence(contact);
+	contact_presence = purple_contact_info_get_presence(info);
 
 	g_object_bind_property(buddy_presence, "idle", contact_presence, "idle",
 	                       G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL);
diff --git a/libpurple/purpleperson.h b/libpurple/purpleperson.h
--- a/libpurple/purpleperson.h
+++ b/libpurple/purpleperson.h
@@ -35,13 +35,13 @@
 #define PURPLE_TYPE_PERSON (purple_person_get_type())
 G_DECLARE_FINAL_TYPE(PurplePerson, purple_person, PURPLE, PERSON, GObject)
 
-#include <libpurple/purplecontact.h>
+#include <libpurple/purplecontactinfo.h>
 
 /**
  * PurplePerson:
  *
- * A collection of [class@Purple.Contact] that contains a user selectable custom
- * avatar and alias.
+ * A collection of [class@Purple.ContactInfo] that contains a user selectable
+ * custom avatar and alias.
  *
  * Since: 3.0.0
  */
@@ -143,43 +143,42 @@
 /**
  * purple_person_add_contact:
  * @person: The instance.
- * @contact: The contact to add.
+ * @info: The [class@Purple.ContactInfo] to add.
  *
- * Adds @contact to @person.
+ * Adds @info to @person.
  *
  * Duplicate contacts are currently allowed, but that may change at a later
  * time.
  *
  * Since: 3.0.0
  */
-void purple_person_add_contact(PurplePerson *person, PurpleContact *contact);
+void purple_person_add_contact_info(PurplePerson *person, PurpleContactInfo *info);
 
 /**
- * purple_person_remove_contact:
+ * purple_person_remove_contact_info:
  * @person: The instance.
- * @contact: The contact to remove.
+ * @info: The [class@Purple.ContactInfo] to remove.
  *
- * Removes @contact from @person.
+ * Removes @info from @person.
  *
- * Returns: %TRUE if @contact was found and removed otherwise %FALSE.
+ * Returns: %TRUE if @info was found and removed otherwise %FALSE.
  *
  * Since: 3.0.0
  */
-gboolean purple_person_remove_contact(PurplePerson *person, PurpleContact *contact);
+gboolean purple_person_remove_contact_info(PurplePerson *person, PurpleContactInfo *info);
 
 /**
- * purple_person_get_priority_contact:
+ * purple_person_get_priority_contact_info:
  * @person: The instance.
  *
- * Gets the priority contact for @person. A priority contact is the one that is
- * the most available.
+ * Gets the contact info for the most available contact info in @person.
  *
  * Returns: (transfer none) (nullable): The priority contact or %NULL if
  *          @person does not have any contacts.
  *
  * Since: 3.0.0
  */
-PurpleContact *purple_person_get_priority_contact(PurplePerson *person);
+PurpleContactInfo *purple_person_get_priority_contact_info(PurplePerson *person);
 
 G_END_DECLS
 
